<?php //mysql.inc.php (table-xs v1.0)


class mysql
/*
   Die Datenquelle ist eine MySQL-Datenbank
*/
{

	// ffentliche Klassenvariablen, auf die von aussen zugegriffen werden kann
	var $name	= "";
	var $handle	= "";
	var $server	= "";
	var $database   = "";
	var $user	= "";
	var $password	= "";
	var $captions   = array();


//-------------------------------- Hilfsfunktionen -------------------------------------

	function get_captions()
	// Aufgabe:  Ermittelt die Tabellenberschriften 
	//
	// Eingabe:  keine
	//
	// Rckgabe: Rckgabe der Tabellenberschriften in $captions
	{

		$query = "SELECT * FROM " . $this->name;
		$result = mysql_query( $query, $this->handle );
		$num_entries = mysql_num_rows( $result );

		if ( $num_entries != 0 )
		{
			$tokens = mysql_fetch_array( $result, MYSQL_ASSOC );
		
			$keys = array_keys( $tokens ); $i = 0;
			foreach ($keys as $key)
			{
				$this->captions[$i] = $key;
				$i++;
			}
		}
		
	}
	
	
//--------------------------------- Implementation des Interface ----------------------


	// ffnet die MySQL-Datenbank
	function open( $mode )
	{
		if ( ! $this->handle = mysql_connect( $this->server, $this->user, $this->password ) )
		{ 
			echo "Fehler: Verbindung mit MySQL-Datenbank auf '$this->server' fehlgeschlagen!";
			return false;
		} else 
		   {
				if ( mysql_select_db($this->database) ) 
				{
					return true;
				}
				else
				{
					echo "Fehler: Datenbank '$this->database' nicht gefunden!<br>";
					return false;
				}
		   }
	}

	
	function close()
	// Schliet die CSV-Datei

	{
		return mysql_close( $this->handle );
	}

	
	function init()
	// Initialisiert die Datenquelle

	{
		if ( $this->open( "" ) AND $this->close() )
		{ 
//			echo "Datenbank <b>$this->database</b> steht zur Verfgung...<br>"; 
			return true;
		}
		return false;
	}	

	
	function entries()
	// Aufgabe:  Ermittelt die Anzahl der Eintrge (Datenstze)
	//
	// Eingabe:  keine
	//
	// Rckgabe: Anzahl der Eintrge (Datenstze)

	{
		$this->open("");

		// Tabellenberschriften aus der ersten Zeile einlesen
		$this->get_captions();

		$query = "SELECT * FROM " . $this->name;
		if ( ! $result = @mysql_query( $query, $this->handle )  )
		{
			echo "Fehler: Tabelle '$this->database.$this->name' nicht gefunden...";
			exit;
		}
		$num_entries = mysql_num_rows( $result );
		$this->close();

		return $num_entries;		
	}


	function get_entry( $pos, &$rows )
	// Aufgabe:  Holt einen bestimmten Eintrag aus der Datei
	//
	// Eingabe:  $line	= Nummer der zu holenden Tabellenzeile
	//
	// Rckgabe: $rows 	= Array mit den gelesenen Eintrgen
	{

		$this->open( "r");

		// Tabellenberschriften aus der ersten Zeile einlesen
		$this->get_captions();

		$query = "SELECT * FROM " . $this->name;
		$result = mysql_query( $query, $this->handle );
		
// ! Fehlende Bereichsberprfung fr pos
		while ($i < $pos)
		{
			$tokens = mysql_fetch_array( $result, MYSQL_ASSOC );
			$i++;
		}
		$rows = mysql_fetch_array( $result, MYSQL_ASSOC );

		$this->close();

	}


	function get_entrylist( $start, $stop, &$entrylist )
	// Aufgabe:  Liefert einen bestimmten Ausschnitt der Tabelle
	//
	// Eingabe:  $start	= Erster zu holender Eintrag
	//           $end	= Letzter zu holender Eintrag
	//
	// Rckgabe: $entrylist = Array mit den gelesenen Eintrgen
	{

		$this->open( "r" );

		// Tabellenberschriften aus der ersten Zeile einlesen
		$this->get_captions();
	
		$i=0;
		$query = "SELECT * FROM " . $this->name . " ORDER BY id";
		$result = mysql_query( $query, $this->handle );

// ! Fehlende Bereichsberprfung fr start
		while ($i < $start)
		{
			$tokens = mysql_fetch_array( $result, MYSQL_ASSOC );
			$i++;
		}
		
		while ( ($i <= $stop) )
		{
			$entrylist[$i] = mysql_fetch_array( $result, MYSQL_ASSOC );
			$i++;
		}

		$this->close();		

	}


	function append( $data )
	// Aufgabe:  Hngt die Daten an das Ende der Datenbasis
	//
	// Eingabe:  $data	= Array mit den zu speichernden Daten
	//
	{

		$this->open( "a" );

		// Tabellenberschriften aus der ersten Zeile einlesen
		// $this->get_captions();
	
		$query = "INSERT INTO " . $this->name ." ( ";
		
//		$values = array_values( $this->captions );
	   $values = array_keys( $data );
		$preset_commata = false;
		foreach ($values as $val)
		{
			if (!$preset_commata) { $query .= $val; $preset_commata = true; }
			else { $query .= "," . $val; }
		}
		$query .= ") VALUES ( ";
		
//		$values = array_values( $this->captions );
		$values = array_keys( $data );
		$preset_commata = false;
		foreach ($values as $val)
		{
			if (!$preset_commata) { $query .= "'".$data[$val]."'"; $preset_commata = true; }
			else { $query .= "," . "'" . $data[$val] . "'"; }
		}
		$query .= " );";
//		echo "Query: $query<br>";

		$result = mysql_query( $query, $this->handle );

	}
	

	function find_entry( $data )
	// Aufgabe:  Sucht nach dem ersten Auftreten eines Datums
	//
	// Eingabe:  $data	= Gesuchtes Datum
	//
	{
		$ok = false; $entry = 0;
		$this->open( "r" );
		$this->get_captions();
		
		$i=0;
		$query = "SELECT * FROM " . $this->name;
		$result = mysql_query( $query, $this->handle );
		
		while ( ($line = mysql_fetch_array( $result, MYSQL_ASSOC )) AND (!$ok) )
		{
			$values = array_values( $line );
			foreach ($values as $val)
			{
				if ($val == $data ) { $ok = true; }
			}
			if (!$ok) {$entry++;}
		}

		$this->close();
		return $entry;
		
	}
	
	
	function change( $pos, $data )
	// Aufgabe:  ndert eine bestimmte Zeile in der Tabelle
	//
	// Eingabe:	$pos	= Position des Elements
	//		$data	= Array mit den zu speichernden Daten
	//
	{

		$num_of_entries = $this->entries();

		$this->open( "r" );
		$this->get_captions();

		$i=0;
		$query = "SELECT * FROM " . $this->name;
		$result = mysql_query( $query, $this->handle );

		// bis zur Spalte $pos durchlaufen
		while ($i <= $pos)
		{
			$tokens = mysql_fetch_array( $result, MYSQL_ASSOC );
			$i++;
		}
	   // und ID ermitteln
		$id = $tokens["id"];
		
		$query = "UPDATE ".$this->name." SET "; // ... WHERE id = ".$id;

		$values = array_values( $this->captions );
		$preset_commata = false;
		foreach ($values as $val)
		{
			if ($val != "id" )
			{			
				if (!$preset_commata) 
				{
					$query .= $val ." = ". '"'.$data[$val].'"'; $preset_commata = true; 
				}
				else 
				{ 
					$query .= ", " . $val ." = ". '"' . $data[$val] .'"'; 
				}
			}
		}
		$query .= " WHERE id = ".$id;
//		echo $query."<br>";
		$result = mysql_query( $query, $this->handle );
		
		$this->close();
	
	}
	
	function delete( $pos )
	// Aufgabe:  Lscht eine bestimmte Zeile in der Tabelle
	//
	// Eingabe:	$pos	= Position des Elements
	//
	{
		$num_of_entries = $this->entries();

		$this->open( "r" );

		$i=0;
		$query = "SELECT * FROM " . $this->name;
		$result = mysql_query( $query, $this->handle );

		// bis zur Spalte $pos durchlaufen
		while ($i <= $pos)
		{
			$tokens = mysql_fetch_array( $result, MYSQL_ASSOC );
			$i++;
		}
	   // und ID ermitteln
		$id = $tokens["id"];
		
		$query = "DELETE FROM ".$this->name." WHERE id = ".$id;
//		echo $query."<br>";
		$result = mysql_query( $query, $this->handle );
		
		$this->close();	
	
	}
	
	
	
}
?>